unit JpegInDBForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Mask, DBCtrls, DB, DBTables, Jpeg, Math,
  ExtDlgs;

type
  TForm1 = class(TForm)
    Table1: TTable;
    DataSource1: TDataSource;
    DBNavigator1: TDBNavigator;
    DBEdit1: TDBEdit;
    Image1: TImage;
    BitBtn1: TBitBtn;
    Label1: TLabel;
    Dlg: TOpenPictureDialog;
    procedure BitBtn1Click(Sender: TObject);
    procedure Table1AfterScroll(DataSet: TDataSet);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function StretchImageRatio(FileName : TFileName; Width, Height, Quality : Integer; Center : Boolean) : TJpegImage;
var
  bmp, tempbmp : TBitmap;
  RT : TRect;
  Ratio : Double;
  NewW, NewH : Integer;
begin
  result := TjpegImage.Create;
  bmp := TBitmap.Create;
  tempbmp := TBitmap.Create;
  try
    if Uppercase(ExtractFileExt(FileName)) = '.JPG' then
    begin
      result.LoadFromFile(FileName);
      Ratio := Min(Width / result.Width, Height / result.Height);
      NewW := Round(result.Width * Ratio);
      NewH := Round(result.Height * Ratio);
    end
    else if Uppercase(ExtractFileExt(FileName)) = '.BMP' then
    begin
      tempbmp.LoadFromFile(FileName);
      Ratio := Min(Width / tempbmp.Width, Height / tempbmp.Height);
      NewW := Round(tempbmp.Width * Ratio);
      NewH := Round(tempbmp.Height * Ratio);
    end
    else
      exit;
    if Center then
    begin
      bmp.Width := Width;
      bmp.Height := Height;
      RT.Left := Floor(Abs(Width-NewW)/2);
      RT.Top := Floor(Abs(Height-NewH)/2);
      RT.Right := RT.Left + NewW;
      RT.Bottom := RT.Top + NewH;
    end
    else
    begin
      bmp.Width := NewW;
      bmp.Height := NewH;
      RT.Left := 0;
      RT.Top := 0;
      RT.Right := bmp.Width - 1;
      RT.Bottom := bmp.Height - 1;
    end;
    if Uppercase(ExtractFileExt(FileName)) = '.JPG' then
      bmp.Canvas.StretchDraw(RT,result)
    else
      bmp.Canvas.StretchDraw(RT,tempbmp);
    result.CompressionQuality := Quality;
    result.Assign(bmp);
  finally
    tempbmp.Free;
    bmp.Free;
  end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  S : TBlobStream;
begin
  if not Dlg.Execute then exit;
  if not (Table1.state in [dsEdit, dsInsert]) then
    Table1.Edit;
  S := TBlobStream.Create(TBlobField(Table1.FieldByName('Pic')),bmWrite);
  try
    Image1.Picture.Assign(StretchImageRatio(Dlg.FileName,300,300,70,true));
    Image1.Picture.Graphic.SaveToStream(S);
  finally
    S.Free;
  end;
end;

procedure TForm1.Table1AfterScroll(DataSet: TDataSet);
var
  jpeg : TJpegImage;
  S : TBlobStream;
begin
  if (not Table1.Active) or (Table1.FieldByName('PIC').Value = '') or (Table1.FieldByName('PIC').Value = null) then
  begin
    Image1.Picture := nil;
    exit;
  end;
  S := TBlobStream.Create(TBlobField(Table1.FieldByName('Pic')), bmRead);
  jpeg := TJpegImage.Create;
  try try
    jpeg.LoadFromStream(S);
    Image1.Picture.Assign(jpeg);
  except
  end;
  finally
    S.Free;
    jpeg.Free;
  end;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  Table1.Active := true;
end;

end.
